"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.gulpParallel = exports.parallel = exports.gulpSeries = exports.series = exports._revertSymbolParallel = exports._revertSymbolSeries = void 0;
const module_1 = require("module");
exports._revertSymbolSeries = Symbol.for('@@originalList:series');
exports._revertSymbolParallel = Symbol.for('@@originalList:parallel');
function wrapList(tasks, symbol) {
    const wrapTasks = [];
    for (const item of tasks) {
        if (Array.isArray(item)) {
            wrapTasks.push(...item);
        }
        else if (typeof item === 'string') {
            wrapTasks.push(item);
        }
        else if (symbol in item) {
            wrapTasks.push(...item[symbol]);
        }
        else {
            wrapTasks.push(item);
        }
    }
    return wrapTasks;
}
function series(gulp, ...tasks) {
    const wrapTasks = wrapList(tasks, exports._revertSymbolSeries);
    return Object.assign(gulp.series(...wrapTasks), { [exports._revertSymbolSeries]: wrapTasks });
}
exports.series = series;
function gulpSeries(...tasks) {
    const wrapTasks = wrapList(tasks, exports._revertSymbolSeries);
    return Object.assign(parentGulp().series(...wrapTasks), { [exports._revertSymbolSeries]: wrapTasks });
}
exports.gulpSeries = gulpSeries;
function parallel(gulp, ...tasks) {
    const wrapTasks = wrapList(tasks, exports._revertSymbolParallel);
    return Object.assign(gulp.parallel(...wrapTasks), { [exports._revertSymbolParallel]: wrapTasks });
}
exports.parallel = parallel;
function gulpParallel(...tasks) {
    const wrapTasks = wrapList(tasks, exports._revertSymbolParallel);
    return Object.assign(parentGulp().parallel(...wrapTasks), { [exports._revertSymbolParallel]: wrapTasks });
}
exports.gulpParallel = gulpParallel;
let gulpInstance;
function parentGulp() {
    if (!gulpInstance) {
        const require = (0, module_1.createRequire)(("file://" + __filename));
        const mainRequire = (0, module_1.createRequire)(require.main?.filename || '.');
        try {
            gulpInstance = mainRequire('gulp');
        }
        catch (e) {
            if (e.code !== 'MODULE_NOT_FOUND' && e.code !== 'ERR_MODULE_NOT_FOUND') {
                throw e;
            }
            console.error('[%s] %s from %s', e.code, e.message, require.main?.filename);
        }
    }
    return gulpInstance;
}
//# sourceMappingURL=index.cjs.map
